#include <cstdlib>
#include <string>
#include <sstream>

#include <SDL/SDL.h>

#include <SDL_gfxPrimitives.h>
#include "SDL_gfx_5x7_fnt.h"

#include "wiz_buttons.h"

void play_intro(SDL_Surface *buffer);

int main(int argc, char *argv[])
{
	init_button_mapping();
	gfxPrimitivesSetFont(& SDL_gfx_font_5x7_fnt,5,7);
	SDL_Init(SDL_INIT_VIDEO);

	SDL_Surface *screen=SDL_SetVideoMode(320,240,16,SDL_SWSURFACE);
	SDL_ShowCursor(false);

	int buttons;
	int delay=0;
	std::string delay_str;

	bool up_released=true, down_released=true;
	do
	{
		buttons=get_button_state();

		if(!up_released && !(buttons & BTN_UP)) up_released=true;
		if(!down_released && !(buttons & BTN_DOWN)) down_released=true;

		if((buttons & BTN_UP) && up_released)
		{
			++delay;
			up_released=false;
		};
		if((buttons & BTN_DOWN) && down_released)
		{
			if(delay>0) --delay;
			down_released=false;
		};
		

		std::stringstream str;
		str<<delay;
		str>>delay_str;

		std::string tmp="Shutdown in "+delay_str+" minutes";

		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
		stringRGBA(screen,160-tmp.size()*5/2,112,tmp.c_str(),255,255,255,255);
		stringRGBA(screen,85,220,"Press B or Menu to confirm ;-)",255,255,255,255);

		SDL_Flip(screen);
	}while(!(buttons & BTN_B) && !(buttons & BTN_MENU));

	exit_buttons();
	system(("./shutdown.gpe "+delay_str+" &").c_str());

	SDL_Quit();

	return 0;
};
